#include <Adafruit_NeoPixel.h>

#define PIN D2
#define NUMPIXELS 8

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  pixels.begin();
  pixels.show();
}

void loop() {
  // Phase 1: Flowing Rainbow Blend  
  for (int j = 0; j < 256; j += 5) {  // Slow transition for drama  
    for (int i = 0; i < NUMPIXELS; i++) {
      int pixelHue = (j + (i * 16)) % 256;  // Staggered hues
      pixels.setPixelColor(i, pixels.ColorHSV(pixelHue * 256, 255, 255));
    }
    pixels.show();
    delay(50);
  }

  // Phase 2: Pulsing Fiery Glow 🔥
  for (int k = 0; k < 3; k++) {  
    for (int i = 0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(255, 100, 0));  // Warm Orange
    }
    pixels.show();
    delay(300);

    for (int i = 0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(180, 0, 0));  // Deep Red
    }
    pixels.show();
    delay(300);
  }

  // Phase 3: Electric Twinkle ⚡️✨
  for (int j = 0; j < 20; j++) {
    int pixelIndex = random(NUMPIXELS);
    pixels.setPixelColor(pixelIndex, pixels.Color(random(255), random(255), random(255)));  // Random color sparks
    pixels.show();
    delay(50);
    pixels.setPixelColor(pixelIndex, 0);
  }

  delay(1000);  // Dramatic pause before looping again  
}